package com.wily.introscope.agent.jmx;

import java.lang.instrument.Instrumentation;
import java.util.HashMap;

import com.wily.introscope.agent.AgentShim;
import com.wily.introscope.agent.IAgent;
import com.wily.introscope.agent.service.ServiceAdministrator;

public class JMXStartupStub {
    // MBean methods
    public String getDescription() {
        return "IntroScope Agent JMX Connector";
    }

    public void start() throws Throwable {
        try {
            connectToJMX();
       } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void stop() throws Exception {
    }
    private static final String NAME = "JMX";

    // Makes us an Agent from a java.lang.instrument point of view
    public static void premain(String agentArgs, Instrumentation inst) {
        try {
            new JMXStartupStub().start();
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }

    // Do the work
    private void connectToJMX() throws Exception {
        IAgent agent = AgentShim.getAgentShim().IAgentShim_getAgent();
        ServiceAdministrator serviceAdministrator = agent.IAgent_getServiceAdministrator();
        serviceAdministrator.registerServiceAsync(agent, "JMX", new JMXDelegatingService(), new HashMap());
    }
}
